! Info: tests all facilities in omsourceutils_mod
program main
   use omsourceutils_mod
   implicit none

   call testSorted
   call testMedian
   

contains

   subroutine testSorted
      real(single),  parameter :: uv(5)=(/5.,1.,3.,2.,4./)
      real(single),  parameter :: sv(5)=(/1.,2.,3.,4.,5./)
      integer(int32),parameter :: si(5)=(/2,4,3,5,1/)

      call assertOn(any(sortedIndexOf(uv) /= si),"failing sortedIndexOf()")
      call assertOn(any(sorted(uv) /= sv),"failing sorted()")
   end subroutine testSorted



   subroutine testMedian
      real(single),  parameter :: uv1(5)=(/5.,1.,3.,2.,4./)
      real(single),  parameter :: uv2(6)=(/3.,2.,1.,1.,2.,3./)

      ! if OK, then medianOfSorted() is also tested, because of 
      ! testSorted()
      call assertOn(medianOfUnsorted(uv1) /= 3.,"failed median of v(5)")
      call assertOn(medianOfUnsorted(uv2) /= 2.,"failed median of v(5)")
   end subroutine testMedian




end program main
