// -*-C++-*-
//
// File:      OmImageDisplay.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Sep  6 12:09:43 MEST 2002
// Usage:     -
// Info:      -

#ifndef OmImageDisplay_h
#define OmImageDisplay_h

#include "Ds9.h"
#include "OmSourceParameters.h"
#include <vector>
#include <cstdio>
#include "OmSourceTempFile.h"
#include <iostream>
#include <cstring>
class OmSourceRegions;
class OmImageDisplay : public Ds9
{
public:
  OmImageDisplay() 
  {
       if (strlen(_regionFile) < 2) TempFile::createTempFile(_regionFile);};
  ~OmImageDisplay() {remove(_regionFile); };
  void toRegion(const OmSourceParameters&,  const bool deleteRegions = true);
  void displayCurrentSourceList();
  void displayBackgroundRegions(const OmSourceParameters&);
  void displayBackgroundRegions(const OmSourceRegions *, const float radius);
  void displayBackgroundRegions(const OmSourceRegions *, const vector<float>& radius);
  void displaySourceRegions(const OmSourceParameters&);
  void displaySourceRegions(const OmSourceRegions *, const float radius);


  void displaySourceRegions(const OmSourceRegions *, const vector<float>& radius);


  void deleteRegions(const OmSourceRegions* sources);


  void zoomTo(const OmSourceParameter&, int zoomFactor = 15);
  void displaySource(const int no, const OmSourceParameter&);

  void plotPoint(const OmSourceParameter& s);

protected:
  // only derived classes can use these

private:
  // member functions
  OmImageDisplay(const OmImageDisplay&);
 
  OmImageDisplay& operator=(const OmImageDisplay&);
  static char _regionFile[100];
  // member data
  /*
    ???BUG: cannot use any member on xmmps03???
    int xMax;
   */
};



#endif



