#ifndef OmSourceBackgroundDlg_h
#define OmSourceBackgroundDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>

#include "OmSourceVersionNo.h"
#include <vector>



class   OmSourceParameters;
class OmSourceButton;
class OmSourceLabel;
class QTable;
class OmImageDisplay;
class QTimer;
class OmSourceParameter;
class OmSourceLabel;
class QSpinBox;
class Average;



/*********************************************************
 *
 *
 ********************************************************/
class AddSourcesDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
      void deleteList();    
    void mousePressEvent( QMouseEvent *e );
    void updateRegions(); 
    void apertureRadiusHasChanged(int radius);
    void accept1();    

public:
    AddSourcesDlg(QWidget *parent,  OmImageDisplay *imageDispaly, float);
    ~AddSourcesDlg();
 
 private:

    void updateTable(float x, float y, float radius, 
           float counts, float countsError);
    void update();

    OmImageDisplay *_imageDisplay;
    OmSourceParameter* _source;
   
    OmSourceButton* _deleteListBtn;    
    OmSourceLabel* _label;
    QTable *_table;
    QTimer *_timer;
    //    int _noBackgroundSources; 
    float _apertureRadius; 

    OmSourceLabel* _apertureTxt;
    QSpinBox* _apertureSpinBox;
  
 
    static vector<float>  _radiusList; 
  
};

#endif




