#ifndef OmSourceBackgroundDlg_h
#define OmSourceBackgroundDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>

#include "OmSourceVersionNo.h"
#include <vector>



class   OmSourceParameters;
class OmSourceButton;
class QTable;
class OmImageDisplay;
class QTimer;
class OmSourceParameter;
class OmSourceLabel;
class QSpinBox;
class Average;




class BackgroundDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
    void deleteList();    
    void mousePressEvent( QMouseEvent *e );
    void updateRegions(); 
    void apertureRadiusHasChanged(int radius);
     

public:
    BackgroundDlg(QWidget *parent,  OmImageDisplay *imageDispaly,  OmSourceParameter* source, int zoomFactor);
    ~BackgroundDlg();
    float getBackgroundMode() const {return _backgroundMode; };
 private:

    void updateTable(float x, float y, float radius, 
           float counts, float countsError);
    void update();

    OmImageDisplay *_imageDisplay;
    OmSourceParameter* _source;
    int _zoomFactor;
    OmSourceButton* _deleteListBtn;    
    QTable *_table;
    QTimer *_timer;
    //    int _noBackgroundSources; 
    float _apertureRadius; 

    OmSourceLabel* _apertureTxt;
    QSpinBox* _apertureSpinBox;
    OmSourceLabel* _averageTxt;    
    float _backgroundMode;
    Average* _average;
    static vector<float>  _radiusList; 
  
};

#endif



