#ifndef DeconvolveDlg_h
#define DeconvolveDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
class QSpinBox;

class QLabel;;
class QLineEdit;
class QString;
class QCheckBox;
#include  "OmSourceParameters.h"

class DeconvolveDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
  
    void quit();
    void setNoSources(int no);

    void setSourceParameters(int);
    void xPosChanged(const QString &);
    void yPosChanged(const QString &);
    void i0Changed(const QString &);
    void backgroundChanged(const QString &);
    void fixParameterBackground();
 
    void fixParameterXpos();
    void fixParameterYpos();
    void fixParameterI0();
  
    void compute();  
 
    public:
    DeconvolveDlg(QWidget *parent, int no, OmSourceParameter* _source);
   
 
    
 private:
    double getValue(const QString &text, double min, double max);
    void initialise(); 
    OmSourceParameter* _source; 
    int _noSources;    
    int _sourceIndex;  
    int _sourceNo;
    int _status;
    QLabel *_label;    

    QPushButton* _quitButton;
    QPushButton* _computeButton;

    QSpinBox* _noSourcesSpinBox;
    QSpinBox* _sourceNoSpinBox;


    QLineEdit* _backgroundEdit;
    QCheckBox* _backgroundCheck;

    QLineEdit* _xPosEdit;
    QCheckBox* _xPosCheck;
    QLineEdit* _yPosEdit;
    QCheckBox* _yPosCheck;
  
    QLineEdit* _i0Edit;
    QCheckBox* _i0Check;
 
    LsqData _data;
 
};
#endif





