#include <qtooltip.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qwidget.h>
#include <qlabel.h>
#include "OmSourceEdit.h"
#include <qfont.h>
#include <qfontinfo.h>
#include <qfontmetrics.h>

OmSourceEdit::OmSourceEdit(QWidget *parent, QString title, 
       int x, int y, int height, QString help) :
       QLineEdit(parent, title)
{
    
      
    QFontMetrics fm = this->fontMetrics();
    
 
    int pixelWidth = fm.width(title ) + 5;

       
    setGeometry(x, y, pixelWidth, height);


   
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
   
    setReadOnly(true);


    if (help)   
        QToolTip::add(this, help);

};
OmSourceEdit::OmSourceEdit(QWidget *parent, QString title, 
       int x, int y, int width, int height, QString help) :
       QLineEdit(title, parent)
{
    
   
   
    setGeometry(x, y, width, height);
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    setReadOnly(true);
         

    if (help)   
        QToolTip::add(this, help);

};
void OmSourceEdit::setText(const QString &text)
{
   
    QFontMetrics fm = this->fontMetrics();
 
    int pixelWidth = fm.width(text ) + 5;

       
    setGeometry(x(), y(), pixelWidth, height());

    QLineEdit::setText(text);
}
 








