





#include <qhbox.h>
#include <qhbox.h>
#include <qpushbutton.h>
#include <qtextview.h>
#include <qbrush.h>
#include <qapplication.h>

#include "OmSourceHelp.h"


MyRichText::MyRichText( QWidget *parent, const QString text[])
  : QVBox( parent )
{
    int size = 0;
    while (text[size]) {size++; };
    
    _text = new QString[size + 1];
    for (int i = 0; i < size; i++)
      _text[i] = text[i];

    _text[size] = QString::null;    
     
    setMargin( 5 );
    
    view = new QTextView( this );
    view->setText( "This is a <b>Test</b> with <i>italic</i> <u>stuff</u>" );
    QBrush paper;
    paper.setPixmap( QPixmap( "../richtext/marble.png" ) );
    if ( paper.pixmap() != 0 )
        view->setPaper( paper );
    else
        view->setPaper( white );

    view->setText( _text[0] );
    view->setMinimumSize( 450, 250 );

    QHBox *buttons = new QHBox( this );
    buttons->setMargin( 5 );

    bClose = new QPushButton( "&Close", buttons );
    bPrev = new QPushButton( "<< &Prev", buttons );
    bNext = new QPushButton( "&Next >>", buttons );

    bPrev->setEnabled( FALSE );

    connect( bClose, SIGNAL( clicked() ), parentWidget(), SLOT( close() ) );
    connect( bPrev, SIGNAL( clicked() ), this, SLOT( prev() ) );
    connect( bNext, SIGNAL( clicked() ), this, SLOT( next() ) );

    num = 0;
}

void MyRichText::prev()
{
    if ( num <= 0 )
        return;

    num--;

    view->setText( _text[num] );

    if ( num == 0 )
        bPrev->setEnabled( FALSE );

    bNext->setEnabled( TRUE );
}

void MyRichText::next()
{
    if ( !_text[++num] )
        return;

    view->setText( _text[num] );

    if ( !_text[num + 1] )
        bNext->setEnabled( FALSE );

    bPrev->setEnabled( TRUE );
}

#include <qfont.h>
#include <qdialog.h>
/********************************************************************************
 * Dialog for running omdetect- allows you to change the parameters nsigma
 * and minsignificance.          
 *
 *******************************************************************************/

HelpDlg::HelpDlg(QWidget *parent, const QString text[]) :
  QDialog(parent, "", true)
{

   
    
   _text = new MyRichText(this, text);
   _text->setGeometry(50, 50, 400, 600);
   _text->show();
   


};




