#include <qtooltip.h>
#include <qstring.h>
#include <qlabel.h>
#include <qwidget.h>
#include "OmSourceLabel.h"
#include <qfont.h>
#include <qfontinfo.h>
#include <qfontmetrics.h>

OmSourceLabel::OmSourceLabel(QWidget *parent, QString title, 
       int x, int y, int height, QString help) :
       QLabel(title, parent)
{
    
    QFont f = font();
   
   
    QFontMetrics fm( f );
 
    int pixelWidth = fm.width(title ) + 3;
    
       
    setGeometry(x, y, pixelWidth + 2, height);


    //    setFrameStyle( QFrame::Panel | QFrame::Raised );
    setFrameStyle( QFrame::Panel | QFrame::Sunken );
   
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    //    setPaletteBackgroundColor(QColor(255, 0, 0));    
    //    setPaletteBackgroundColor(QColor(0, 0, 255));    
   setPaletteBackgroundColor(QColor(156, 156, 156));    

    if (help)   
        QToolTip::add(this, help);

};
OmSourceLabel::OmSourceLabel(QWidget *parent, QString title, 
       int x, int y, int width, int height, QString help) :
       QLabel(title, parent)
{
    
   
   
    setGeometry(x, y, width, height);
    

    //    setFrameStyle( QFrame::Panel | QFrame::Raised );
    setFrameStyle( QFrame::Panel | QFrame::Sunken );
   
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    
    //    setPaletteBackgroundColor(QColor(0, 0, 255));    
  setPaletteBackgroundColor(QColor(156, 156, 156));    

    if (help)   
        QToolTip::add(this, help);

};
void OmSourceLabel::setText(QString &title)
     
{
    
    QFont f = font();
   
   
    QFontMetrics fm( f );
 
    int pixelWidth = fm.width(title ) + 3;
  
    int x = this->x();
    int y = this->y();
    int height = this->height();   
 
       
    setGeometry(x, y, pixelWidth + 2, height);


    //    setFrameStyle( QFrame::Panel | QFrame::Raised );
    setFrameStyle( QFrame::Panel | QFrame::Sunken );
   
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    //    setPaletteBackgroundColor(QColor(255, 0, 0));    
    //    setPaletteBackgroundColor(QColor(0, 0, 255));    
   setPaletteBackgroundColor(QColor(156, 156, 156));    
   QLabel::setText(title);
    

};
void OmSourceLabel::setText(char* title)
     
{
  
   QLabel::setText(title);
    

};



