/****************************************************************************
** Form implementation generated from reading ui file 'testdialog.ui'
**
** Created: Mon Feb 24 14:33:07 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

// QT header files
#include <qapplication.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qcombobox.h>
#include <qwhatsthis.h>
#include <qinputdialog.h>
#include <qtimer.h>
#include <cmath>
#include <qstring.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qprinter.h> 
#include <qpainter.h>
#include <qfont.h> 
#include <qpaintdevicemetrics.h> 
#include <qdatetime.h>
#include <qmenubar.h>
#include <qmessagebox.h>

// omsource header files
#include "OmSourceLog.h"
#include "OmImageDisplay.h"
#include "OmSourceRegions.h"
#include "OmSourceVersionNo.h"
#include "OmProgressDialog.h"
#include "OmSourcePhotometryDlg.h"
#include "OmSourceNumerics.h"
#include "OmSourceProcessDlg.h"
#include "OmSourceInformationDlg.h"
#include "OmSourceBackgroundDlg.h"

//#include "OmSourceGraphDlg.h"
#include "OmSourceBrowser.h"
#include "OmSourceButton.h"
#include "OmSourceGroupBox.h"
#include "OmSourceLabel.h"
#include "OmSourceInformationMenu.h"
#include "OmSourceHelp.h" 
#include "OmSourceEdit.h"
#include "OmSourceRegions.h"
#include "OmSourceLabelEdit.h"
//#include "graph.h"
/* 
 *  Constructs a PhotometryDlg which is a child of 'parent', with the computeB
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */

// FORTRAN prototypes
F90MODPROCPROTO(void,omsource_glue, recompute)(const int& id);
F90MODPROCPROTO(void, omsource_glue, replace)(const int &id, OmSourceParameter& source);
F90MODPROCPROTO(void, omsource_glue, getbackgroundregions)(OmSourceRegions *regions);
F90MODPROCPROTO(void, omsource_glue, getthecounts)(const float &radius);
F90MODPROCPROTO(void, omsource_glue, getsourcecounts)(const float &x, 
             const float &y, const float &radius, float &counts);
F90MODPROCPROTO(void, omsource_glue, getthebackgroundcounts)(const float &x, 
             const float &y, const float &radius, float &r1, float &r2, float &counts);
F90MODPROCPROTO(void, omsource_glue, computebackground)(float &counts, float &error);
F90MODPROCPROTO(void,omsource_glue, deletebackgroundlist)();
F90MODPROCPROTO(float, omsource_glue, getthebackgroundmode)();

  
extern F90MODVARDEF(OmSourceParameters, omsource_glue, mysources);
extern F90MODVARDEF(OmSourceParameters, omsource_glue, mybackgroundsources);
extern F90MODVARDEF(PhotometryParameters, omsource_glue, myphotometryparameters);

 
/***************************************
* Constructor
***************************************/
PhotometryDlg::PhotometryDlg(const int no, 
			OmImageDisplay *displayIn, 
                        const OmSourceBrowser::ObsDetails* obsDetails,
                        const OmSourceBrowser::ImageDetails* imageDetails,
                        QWidget* parent,  
                        const char* name, 
                        bool modal, 
                        WFlags fl)
  : QDialog( parent, name, modal, fl ), 
  _sourceNo(no), _display(displayIn),  _obsDetails(obsDetails),  
  _imageDetails(imageDetails), _zoomFactor(6), _displayUpdated(false),  // was 5
  _fixedBackground(false)
{


    //  QToolTip::add(this, "This is a test");
    string text2 = "Constructing photometry window- please wait";
   
    OmProgressDialog *reporter = new OmProgressDialog(text2, 41);
    
    reporter->setProgress(1);
   
     // load display
    _display = new OmImageDisplay;
     
    reporter->setProgress(2);
  

    _background = -1.0;
    _timer = new QTimer(this);
    connect(_timer, SIGNAL(timeout()), SLOT(updateDisplay()) );
  

    if ( !name )
	setName( "Photometry" );
    resize( 580, 950 ); 

  
    QString text;
    text.sprintf("Aperture photometry (Source no %d, Filter=%s, exposure=%6d seconds)", no,  
      (const char*)_obsDetails->filter,  (int)_obsDetails->exposure);

    setCaption( tr( text) );

    int height = 25;
    /*******************************************************
    * Raw count rates
    ******************************************************/
    _rawRateGroupBox = new OmSourceGroupBox( this,  "Raw count rates (counts/sec)",  20, 20, 230, 140,
          "The following rates are those obtained from the source photometry\n"
	  "before any corrections have been made");

    //    QToolTip::add(_rawRateGroupBox, "The following rates are those obtained from the source photometry\n"
    //	  "before any corrections have been made");



    reporter->setProgress(2);
   

    // Total
    int xPos = 130;
    xPos = 10;
    int yPos = 20;
    int pmSpacing = 2;
  
    //    int dx = 70;

    _rawTotalRateTxt = new OmSourceLabel(_rawRateGroupBox, "Total", xPos, yPos, height,
         "(Backgound counts + source counts) / exposure (counts/sec)");
  
 
    xPos += 90;
    _rawTotalRateEdt = new OmSourceEdit(   _rawRateGroupBox, "400.0", xPos, yPos, 50, height); 
    reporter->setProgress(3);
   
  
    xPos = _rawTotalRateEdt->x() +  _rawTotalRateEdt->width() + pmSpacing;
 
    _rawTotalRateErrTxt = new OmSourceLabel(_rawRateGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the total rate (counts/sec)" );
    reporter->setProgress(4);
   
 
    xPos = _rawTotalRateErrTxt->x() +  _rawTotalRateErrTxt->width() + pmSpacing;
 
    _rawTotalRateErrEdt = new OmSourceEdit(   _rawRateGroupBox, "400.0", xPos, yPos, 40, height  ); 
   
  
    // Background
    xPos = 10;
    yPos += 40;
    _rawBackgroundRateTxt = new OmSourceLabel(_rawRateGroupBox, "Background", xPos, yPos, height,
       "Backgound counts / exposure (counts/sec)");
    
   
    xPos += 90;
    _rawBackgroundRateEdt = new OmSourceEdit(   _rawRateGroupBox, "4000.0", xPos, yPos, 50, height ); 
    reporter->setProgress(5);
   
    // Background subtracted

    xPos = 10;
    yPos += 40;
    _rawBackgroundSubtractedRateTxt = new OmSourceLabel(_rawRateGroupBox, "Source",  xPos, yPos, height,
                "Backgound-subtracted counts / exposure (counts/sec)");
      
    xPos += 90;
    _rawBackgroundSubtractedRateEdt = new OmSourceEdit(   _rawRateGroupBox, "4000.0", xPos, yPos, 50, height  ); 
    reporter->setProgress(6);
   
  
    xPos = _rawBackgroundSubtractedRateEdt->x() +  _rawBackgroundSubtractedRateEdt->width() + pmSpacing;
 
    _rawBackgroundSubtractedRateErrTxt = new OmSourceLabel(_rawRateGroupBox, tr( "+/-" ),  xPos, yPos, height);
    reporter->setProgress(7);
   
 
    xPos = _rawBackgroundSubtractedRateErrTxt->x() +  _rawBackgroundSubtractedRateErrTxt->width() + pmSpacing;
 
    _rawBackgroundSubtractedRateErrEdt = new OmSourceEdit( _rawRateGroupBox, "100.0", xPos, yPos, 40, height ); 
  
    reporter->setProgress(8);
   

    /****************************************************************************
     * Corrected count rates
     ***************************************************************************/
    _corrRateGroupBox = new OmSourceGroupBox( this,  "Corrected count rates (counts/sec)", 280, 20, 230, 140,
         "The following rates are those obtained from the source photometry\n"
	  "after the listed corrections have been made");
    //    QToolTip::add(_corrRateGroupBox, "The following rates are those obtained from the source photometry\n"
    //	  "after the listed corrections have been made");
 
    


    // Total
    xPos = 10;
    yPos = 20;
    _corrTotalRateTxt = new OmSourceLabel(_corrRateGroupBox, "Total", xPos, yPos, height,
          "Corrected (Backgound counts + source counts) / exposure (counts/sec)");
    
 
    xPos += 90;
    _corrTotalRateEdt = new OmSourceEdit(   _corrRateGroupBox, "400.0", xPos, yPos, 50, height ); 
    reporter->setProgress(9);
   
  
    xPos = _corrTotalRateEdt->x() +  _corrTotalRateEdt->width() + pmSpacing;
 
    _corrTotalRateErrTxt = new OmSourceLabel(_corrRateGroupBox,  tr( "+/-" ),  xPos, yPos, height,
      "The error in the corrected total rate (counts/sec)" );
  
    reporter->setProgress(10);
   
 
    xPos = _corrTotalRateErrTxt->x() +  _corrTotalRateErrTxt->width() + pmSpacing;
 
    _corrTotalRateErrEdt = new OmSourceEdit(   _corrRateGroupBox, "400.0", xPos, yPos, 40, height  ); 
    reporter->setProgress(11);
   
  
    // Background
    xPos = 10;
    yPos += 40;
    _corrBackgroundRateTxt = new OmSourceLabel(_corrRateGroupBox, "Background", xPos, yPos, height,
         "Corrected backgound counts / exposure (counts/sec)");
    
 
    xPos += 90;
    _corrBackgroundRateEdt = new OmSourceEdit(_corrRateGroupBox, "4000.0", xPos, yPos, 50, height ); 
    reporter->setProgress(12);
   
 

    // Background subtracted

    xPos = 10;
    yPos += 40;
    _corrBackgroundSubtractedRateTxt = new OmSourceLabel(_corrRateGroupBox, "Source",  xPos, yPos, height,
	   "The corrected background-subtracted counts / exposure (counst/sec)");
  
    
 
    xPos += 90;
    _corrBackgroundSubtractedRateEdt = new OmSourceEdit(   _corrRateGroupBox, "4000.0", xPos, yPos, 50, height  ); 
    reporter->setProgress(13);
    
  
    xPos = _corrBackgroundSubtractedRateEdt->x() +  _corrBackgroundSubtractedRateEdt->width() + pmSpacing;
 
    _corrBackgroundSubtractedRateErrTxt = new OmSourceLabel(_corrRateGroupBox, tr( "+/-" ),  xPos, yPos, height,
	    "The error in the corrected background-subtracted count-rate (counts/sec)");
   
    reporter->setProgress(14);
   
    xPos = _corrBackgroundSubtractedRateErrTxt->x() +  _corrBackgroundSubtractedRateErrTxt->width() + pmSpacing;
 
    _corrBackgroundSubtractedRateErrEdt = new OmSourceEdit(   _corrRateGroupBox, "100.0", xPos, yPos, 40, height ); 
    reporter->setProgress(15);
   
 

    /********************************************************
     * Corrections applied
     *******************************************************/
        
    _correctionsGroupBox = new OmSourceGroupBox( this,  "Corrections applied",  20, 170, 190, 180,
	  "The corrections that have been applied in converting from raw to corrected rates");
    //    QToolTip::add(_correctionsGroupBox,  "The corrections that have been applied in converting from raw to corrected rates");

     


    // Total
    xPos = 10;
    yPos = 20;
    _coincCorrectionTxt = new OmSourceLabel(_correctionsGroupBox,  tr( "Coinc-loss"), xPos, yPos, height,
	   "The correction applied (expressed as a percentage) to correct for coincidence-losses");
  

    xPos += 90;
    _coincCorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "4000.0", xPos, yPos, 50, height  ); 
    QToolTip::add(_coincCorrectionEdt,  "The correction applied (expressed as a percentage) to correct for coincidence-losses");
  
 
    xPos = 10;
    yPos += 40;
    _psf1CorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "PSF1",  xPos, yPos, height,
      "The correction (expressed as a percentage) applied to extrapolate,\n"
      "using the point-spread function, the raw counts measured within the\n"
      "aperture radius to that within the coincidence-loss radius");

    reporter->setProgress(16);
   

    xPos += 90;
  
    _psf1CorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "4000.0", xPos, yPos, 50, height ); 
    QToolTip::add(_psf1CorrectionEdt, "The correction (expressed as a percentage) applied to extrapolate,\n"
      "using the point-spread function, the raw counts measured within the\n"
      "aperture radius to that within the coincidence-loss radius");


    xPos = 10;
    yPos += 40;
    _psf2CorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "PSF2",  xPos, yPos, height,
      "A correction (expressed as a percentage), only applicable to UV data,\n"
      " to extrapolate, using the point-spread function, the counts to the\n"
      "area of the UV point-spread function"); 

    xPos += 90;
  
    _psf2CorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "4000.0", xPos, yPos, 50, height ); 
    QToolTip::add(_psf2CorrectionEdt,    "A correction (expressed as a percentage), only applicable to UV data,\n"
      " to extrapolate, using the point-spread function, the counts to the\n"
      "area of the UV point-spread function"); 


    reporter->setProgress(17);
   
 

    xPos = 10;
    yPos += 40;
    _deadFractionCorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "DeadFraction", xPos, yPos, height,
                "The dead-fraction correction applied (expressed as a percentage)\n"
                "((1 / (1 - ccd dead-fraction) - 1) * 100.0");

    xPos += 90;
  
    _deadFractionCorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "3e999", xPos, yPos, 50, height );
    QToolTip::add(_deadFractionCorrectionEdt, "The dead-fraction correction applied (expressed as a percentage)\n"
                                              "((1 / (1 - ccd dead-fraction) - 1) * 100.0");
    reporter->setProgress(18);
   
  
    /*************************************************
     * Instrumental magnitude
     ************************************************/
 
    _magnitudeGroupBox = new OmSourceGroupBox( this,  "Instrumental magnitude",  280, 180, 230, 100,
			 "The magnitude obtained from the corrected count-rate");
   
    //    QToolTip::add(_magnitudeGroupBox, "The following have been computed using the corrected count-rates");


    xPos = 10;
    yPos = 20;
    _magnitudeTxt = new OmSourceLabel(_magnitudeGroupBox, "Magnitude",  xPos, yPos, height);
   
    
 
    xPos += 90;
    _magnitudeEdt = new OmSourceEdit(   _magnitudeGroupBox, "40.9", xPos, yPos, 50, height); 
    QToolTip::add(_magnitudeEdt, "The instrumental magnitude");

    reporter->setProgress(19);
   
 
    xPos = _magnitudeEdt->x() +  _magnitudeEdt->width() + pmSpacing;
 
    _magnitudeErrTxt = new OmSourceLabel(_magnitudeGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the instrumental magnitude");

 
    xPos = _magnitudeErrTxt->x() +  _magnitudeErrTxt->width() + pmSpacing;
   
    _magnitudeErrEdt = new OmSourceEdit(   _magnitudeGroupBox, "0.13", xPos, yPos, 40, height); 
    reporter->setProgress(20);
   
 
    xPos = 10;
    yPos += 40;
    _signalToNoiseTxt = new OmSourceLabel(_magnitudeGroupBox, "Signal/noise",  xPos, yPos, height,
           "The ratio source counts / sqrt(background counts)" );
    
 

    xPos += 90;
    _signalToNoiseEdt = new OmSourceEdit(   _magnitudeGroupBox, "5000.0", xPos, yPos, 50, height,
           "The ratio source counts / sqrt(background counts)" ); 
    reporter->setProgress(21);
   
 


     /***********************************************************
     * Source type
     **********************************************************/
 
    xPos = 20;
    yPos = 360;
    _sourceTypeGroupBox = new OmSourceGroupBox( this,"Source type", xPos, yPos, 150, 110,
                    "Source type can be point or extended" );
    
    //    QToolTip::add(_sourceTypeGroupBox, "A source is considered to be either point-like\n"
    //		  "or extended- for each kind the photometry is computed differenty");


    xPos = 10;
    yPos = 30;
    _pointSource = new QCheckBox( _sourceTypeGroupBox  , "CheckBox1" );
    _pointSource->setGeometry( xPos, yPos, 96, height ); 
    _pointSource->setText( tr( "Point source" ) );
    QToolTip::add(_pointSource, "If checked will treat the photometry as for a point source");

    connect(_pointSource, SIGNAL(toggled(bool)), this, 
          SLOT(pointSourceCheckBoxHasChanged(bool)));
    
      
    yPos += 40;
    _extendedSource = new QCheckBox(_sourceTypeGroupBox , "CheckBox2" );
    _extendedSource->setGeometry( xPos, yPos, 120, height ); 
    _extendedSource->setText( tr( "Extended source"));
    QToolTip::add(_extendedSource, "If checked will treat the photometry as for an extended source\n"
                                   "Note that the method used for correcting for coincidence-losses\n"
                                   "may only be approximate" );

    connect(_extendedSource, SIGNAL(toggled(bool)), this, 
        SLOT(extendedSourceCheckBoxHasChanged(bool)));
    reporter->setProgress(21);
   

    // Information button
    
    yPos = _sourceTypeGroupBox->geometry().bottom() + 20;
    
    xPos = _sourceTypeGroupBox->pos().x();
    _informationButton = new OmSourceButton(this, "Information", xPos, yPos, 25,  
                 "Click here to display observation/image information");    
    connect(_informationButton, SIGNAL(clicked()), parent, SLOT (displayInformation()) );
  
   
    /***********************************************************
    * Background  determination
    **********************************************************/
 
    

    xPos = _sourceTypeGroupBox->pos().x() + _sourceTypeGroupBox->width() + 20;
    yPos = 360;
  

    // Create a button group to contain all buttons
    QButtonGroup *bgroup = new QButtonGroup( this, "Background determination" );
    bgroup->setTitle("Background determination");
    bgroup->setGeometry(xPos, yPos, 200, 200);
    bgroup->resize( 200, 200 );
    connect( bgroup, SIGNAL(clicked(int)), SLOT(updateBackgroundDetermintaion(int)) );

    // Calculate the size for the radio buttons
    int maxwidth = 80;
    int maxheight = 10;
    
    const char *n;
    QFontMetrics fm = bgroup->fontMetrics();


    // Find out the longest function description.
    // Here we make use of the last "0,0"-entry in the
    // ourDrawFunctions-array.
    QString buttonName[4];
    buttonName[0] = "Annulus";
    buttonName[1] = "User regions";
    buttonName[2] = "User value";
    buttonName[3] = QString::null;
    QString toolTipName[3];
    toolTipName[0] =  "Uses the pixels within the user-defined annulus\n"
                      "to determine the background";
    
    toolTipName[1] = "Uses the background regions selected on the image\n"
                     "to determine the background.\n"
                     "A region is selected by positioning the cursor\n"
                     "at the selected point and clicking the\n"
                     "left-mouse button. Each region\n"
                     "is circular with a diameter equal\n"
                     "to the aperture diameter";
    toolTipName[2] = "Uses your background pixel value";
   

    for (int i=0; (n=buttonName[i]) != 0; i++ ) {
        int w = fm.width( n );
        maxwidth = QMAX(w,maxwidth); // QMAX is a macro defined in qglobal.h
                                     // and returns the biggest of to values.
        // Due to its macro nature one should use it with care and with
        // constant parameters only.
    }
 
    maxwidth = maxwidth + 20;                   // allow 30 pixels for radiobuttons
    int y0 = 20;
    for (int i=0; (n = buttonName[i]) != 0; i++ ) {
        _backgroundRadioBtn[i] = new QRadioButton( n, bgroup );
        _backgroundRadioBtn[i]->setGeometry( 10, y0, maxwidth, 30 );
        y0 += 30;
	QToolTip::add( _backgroundRadioBtn[i] , (const char *)toolTipName[i]);
      
    
        maxheight += 30;

    }
    _backgroundRadioBtn[0]->setChecked( TRUE );
    reporter->setProgress(22);
   
 
    xPos = maxwidth + 5;                                            ;
    yPos = 50;                           ;
   
  
    _backgroundBtn = new OmSourceButton( bgroup, "Select ", 
         xPos, yPos, 30,
         "Click here to show the background regions\n"
         "and select new ones");
 
         

    _backgroundBtn->setDisabled(true);
    connect(_backgroundBtn, SIGNAL(clicked()), this, SLOT(showBackgroundDlg()));
    
 

    n = bgroup->title();
    int w = fm.width( n );
    maxwidth = QMAX(w,maxwidth); 


    maxheight += 20;                            // maxheight is now 10 pixels upper margin
                                                // plus number_of_drawfunctions * 30
                                                // plus 10 pixels lower margin   

    maxwidth += 20;                             // add some margin, this results in the
                                                // final width of bgroup

    bgroup->resize( maxwidth, maxheight );      // resize bgroup to its final size
                                                // when no printersupport is provided

 
    /***********************************************************
     * Annuli
     **********************************************************/
    xPos = 340;
    yPos = 360;

   
    xPos = bgroup->pos().x() + bgroup->width() + 20;
  
    _annuliGroupBox = new OmSourceGroupBox( this,  "Annuli (pixels)", xPos, yPos, 160, 225);
    //    QToolTip::add(_annuliGroupBox, "The following controls allow you to change the aperture\n"
    //                                   "and the radii of the inner and outer background radii\n"
    //                                   "If the source is being treated as extended then you\n"
    //		                   "can also use an elliptical aperture");   

    reporter->setProgress(23);
   
    xPos = 10;
    yPos = 20;
   
    _apertureTxt = new OmSourceLabel(_annuliGroupBox, "Aperture",  xPos, yPos, height);



    /*****************************************************************************
     * Need the cal aperture radius (binned) for doing photometry
     ***************************************************************************/
    PhotometryParameters photParameters = F90MODVAR(omsource_glue, myphotometryparameters);
    _calApertureRadius =  photParameters.calApertureRadius; 
    _apertureRadius =  photParameters.apertureRadius;
    _zoomFactor = 3 * photParameters.binX;
    //    cout << "omsourcephotometrydlg line 612 aperture radius=" << _apertureRadius << endl;


    QTextOStream( &text ) << "The aperture radius (allowed values=" << int(_apertureRadius / 2.0 + 0.1)
                          << " - " 
                          << int(_apertureRadius + 0.1) * 2  
                          << " pixels)\n"
                          << "*****************************************************************\n"
                          << "Note that for radii greater than the coincidence-loss radius ("
                          <<   int(_apertureRadius + 0.1)
		          << "pixels)\nthe source will be treated as being extended\n"   
                          << "*******************************************************************";


    QToolTip::add( _apertureTxt, text);
  
 
    xPos += 80; 
    _apertureSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _apertureSpinBox->setGeometry( xPos, yPos, 50, height ); 

    connect(_apertureSpinBox, SIGNAL(valueChanged(int)), this, SLOT(  apertureRadiusHasChanged(int)));
   


      QToolTip::add( _apertureSpinBox, text);
   
 
    xPos = 10;
    yPos += 40;
    _innerBckTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Inner bck"),  xPos, yPos, height);
 
 
  
    xPos += 80;
    _innerBckSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _innerBckSpinBox->setGeometry( xPos, yPos, 50, height ); 
    reporter->setProgress(24);
   
    connect(_innerBckSpinBox,  SIGNAL(valueChanged(int)), 
           this, SLOT(  innerAnnulusRadiusHasChanged(int)));
    text = "";
    if (_calApertureRadius > 12)   	
        QTextOStream( &text) << "Change the background inner annulus radius\n"
			     << "allowed values=aperture radius + 2 - aperture radius + 32 pixels\n"
                            
                             << "Note that the point-spread function\n"
			     << "extends to " <<   _calApertureRadius << " pixels";
       
    else
        QTextOStream( &text) << "Change the background inner annulus radius\n"
                           << "allowed values=aperture radius + 2 - aperture radius + 32 pixels\n"
                           << "Note that the point-spread function\n"
			   << "extends to " <<   _apertureRadius << " pixels";
       
       
    QToolTip::add(_innerBckSpinBox, text);
    QToolTip::add(_innerBckTxt, text);

 
    xPos = 10;
    yPos += 40;
 
    _outerBckTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Outer bck"),  xPos, yPos, height);
    reporter->setProgress(25);
   

    xPos += 80;
    _outerBckSpinBox = new QSpinBox( _annuliGroupBox, "SpinBox2" );
    _outerBckSpinBox->setGeometry( xPos, yPos, 50, height ); 

    QToolTip::add( _outerBckSpinBox ,
                  "Background outer annulus radius\n"
                  "(allowed values=inner background radius + 2 - inner background radius + 32 pixels)");
  
    QToolTip::add( _outerBckTxt ,
                  "Background outer annulus radius\n"
                  "(allowed values=inner background radius + 2 - inner background radius + 32 pixels)");
  

    connect( _outerBckSpinBox, SIGNAL(valueChanged(int)), 
           this, SLOT(  outerAnnulusRadiusHasChanged(int)));
	
 
    xPos = 10;
    yPos += 40;

    _axialRatioTxt = new OmSourceLabel(_annuliGroupBox,  tr( "a/b" ),  
        xPos, yPos, height,
        "Ellipse axial ratio, a/b (1 - 5)" );
    _axialRatioTxt -> setDisabled(true);
 
    xPos += 80;
    _axialRatioSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _axialRatioSpinBox->setGeometry( xPos, yPos, 50, height ); 
    _axialRatioSpinBox->setMinValue(1);
    _axialRatioSpinBox->setMaxValue(5);
    _axialRatioSpinBox->setValue(0);
    _axialRatioSpinBox->setDisabled(true);
    reporter->setProgress(26);
   

    QToolTip::add( _axialRatioSpinBox ,
                  "Ellipse axial ratio, a/b (1 - 5)");
  
    connect( _axialRatioSpinBox, SIGNAL(valueChanged(int)), 
           this, SLOT(  axialRatioHasChanged(int)));
	

    xPos = 10;
    yPos += 40;

    _positionAngleTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Pos angle"), xPos, yPos, height,
        "Angle (degrees) between the x-axis and the semi-major axis of the ellipse, measured anti-clockwise");
    _positionAngleTxt -> setDisabled(true);
 
    reporter->setProgress(27);
   
    xPos += 80;
    _positionAngleSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _positionAngleSpinBox->setGeometry( xPos, yPos, 50, height ); 
    _positionAngleSpinBox->setMinValue(0);
    _positionAngleSpinBox->setMaxValue(180);
    _positionAngleSpinBox->setLineStep(5);


    _positionAngleSpinBox->setValue(0);
    _positionAngleSpinBox -> setDisabled(true);
 

    QToolTip::add( _positionAngleSpinBox,
                  "Position Angle (0-180 degrees)");
  
    connect( _positionAngleSpinBox, SIGNAL(valueChanged(int)), 
           this, SLOT(  positionAngleHasChanged(int)));
	
    xPos = 100; // was 20
    yPos = 560;
    
 

    {
      //    OmSourceGroupBox* group = new OmSourceGroupBox( this,  "Compute", xPos, yPos, 100, 50);
      //    reporter->setProgress(28);
   
    
      //    QHBoxLayout* layout = new QHBoxLayout(group, QHBoxLayout::LeftToRight);
    
      //    layout->setMargin(10);
      //    layout->setSpacing(10);  
         
  
      _computeBtn = new OmSourceButton(this , "Compute photometry", xPos, yPos, 30,           
        "Click here to recompute the instrumental magnitude\nusing the selected aperture and background annulus");
 
   
    //    layout->addWidget( _computeBtn, 1);

    connect(_computeBtn,SIGNAL(clicked()), this, SLOT(stopTimer()));
    connect(_computeBtn,SIGNAL(clicked()), this, SLOT(compute()));
 

    //    _growthCurveBtn = new OmSourceButton(group , "Growth curve",           
    //        "Click here to display an aperture growth-curve");
    //    layout->addWidget( _growthCurveBtn, 1);

 
    //    connect(_growthCurveBtn,SIGNAL(clicked()), this, SLOT(displayGrowthCurve()));
   

    }
    reporter->setProgress(29);
   
 

    // create the logger
    _loggerGroupBox = new OmSourceGroupBox( this, " ",   20, 630, 510, 250);
   

    _logger = new OmSourceLog(_loggerGroupBox); 
    _logger->setGeometry( 10, 20, 490, 120 );
   
    _averageMagList  = new QComboBox(  _loggerGroupBox);
    _averageMagList->setGeometry(10, 170, 350, 30);
    _averageMagList->setDisabled(TRUE);
    QToolTip::add( _averageMagList , "The average-magnitude table\n"
                                     "This table stores the running average magnitude for the selected source\n"
                                     "Computed from all the values stored in the logger table above\n"
                                     "A new entry is added after the apply button is clicked");
    reporter->setProgress(30);
   
   
    /*********************************************************
    * A button to print its contents
    ********************************************************/
    _printAveragesBtn = new OmSourceButton( _loggerGroupBox, "Print averages",  
                           "Click here to print the contents of\nthe average-magnitude table above");
   
    _printAveragesBtn->setGeometry(10, 210, 100 , 35);
    connect(_printAveragesBtn, SIGNAL(clicked()), this, SLOT (print1()) );
   
                                       
    _printAveragesBtn->setDisabled(TRUE);
    
    /*********************************************************
    * A button to delete average-magnitude table contantes
    ********************************************************/
    _deleteAveragesBtn = new OmSourceButton(_loggerGroupBox, "Delete table",
                              "Click here to delete the contents of\n"
                              "the average-magnitude table above" );
  
    _deleteAveragesBtn->setGeometry(130, 210, 100, 35);
    connect(_deleteAveragesBtn, SIGNAL(clicked()), this, SLOT (deleteAverageMagList()) );
   
		
    reporter->setProgress(31);
                
    _deleteAveragesBtn->setDisabled(TRUE);
   
 
    /*********************************************************
    * A button to print the logger
    ********************************************************/
    _printLogBtn = new OmSourceButton(_loggerGroupBox,  "Print table", 
		     "Click here to print the entries in the logger table above");
    _printLogBtn->setGeometry(_loggerGroupBox->width() - 110, 170, 100 , 35); 

    connect(_printLogBtn, SIGNAL(clicked()), this, SLOT (print2()) );
   
    _printLogBtn->setDisabled(TRUE);
    
    reporter->setProgress(32);
   
    LoadSourceDetails();


    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    
    _originalSource = mySources[_sourceNo];
  
    //  cout << "line 861 original inner=" << _originalSource.innerbackgroundradius << endl;
    //  cout << "outer=" << _originalSource.outerbackgroundradius << endl;



    *_source = mySources[_sourceNo];
     
 
   _innerBckRadius = int(_source->innerbackgroundradius + 0.1);
   _outerBckRadius =  int(_source->outerbackgroundradius + 0.1);
     


    _source->rawbackgroundcountrate = -1.0;
    
    _eSource = *_source;
      _pSource = *_source;
  
    if (_source->extensionflag)
    {
    

      _eSource.extensionflag = true; 
            _eSource.photometryradius = _apertureRadius;
            _pSource.photometryradius = _apertureRadius;

    }
    else
      {
      
         _pSource.extensionflag = false; 
         _pSource.photometryradius = _apertureRadius;

         _eSource.photometryradius = _apertureRadius;
         _eSource.innerbackgroundradius =   _innerBckRadius;
         _eSource.outerbackgroundradius =   _outerBckRadius;


  
      } 


    //   initApertureSpinBoxes();


    //    cout << "Omsourcephotometrydlg.cc input aperture radius = " << _source->photometryradius << endl; 

    reporter->setProgress(33);
   
    // NB In the source-list file the aperture-radius is stored as unbinned pixels
    // Want to display it in the table as actual extraction radius
  
    _logger->add((*_source));

    _magnitude = new float[1000];
    _magnitudeError = new float[1000];
    _count = 0;

    computeAverage();
    _computeBtn->setDisabled(true);


 
     // cancel button
    
    yPos = this->height() - 50;
    xPos = this->width() / 3;

    _finishButton = new OmSourceButton( this, "Okay",
         "Click here to return to the main window");
      
    _finishButton->setGeometry(xPos, yPos, 70, 35);

    _finishButton->setDisabled(true);
    connect(_finishButton, SIGNAL(clicked()), this, SLOT(accept()));
    reporter->setProgress(34);
   

 
    xPos += 90;
  
    _cancelButton = new OmSourceButton( this, "Cancel", 
        "Click here to keep the original source parameters and return to the main window");
    _cancelButton->setGeometry(xPos, yPos, 70, 35);
    connect(_cancelButton, SIGNAL(clicked()), this, SLOT(cancel()));
   
   
    // Recompute the average magnitude 
      
    if(!_originalSource.extensionflag)
      
        _pointSource->setChecked(true);
       
       
    else
    {

        _originalSource.alpha = _originalSource.theta + 180.0;
        _originalSource.innerbackgroundradius =   _innerBckRadius;
        _originalSource.outerbackgroundradius =   _outerBckRadius;
 

        _positionAngleSpinBox->setValue(int(_originalSource.alpha));
        _originalSource.axialRatio = int(_originalSource.semia / _originalSource.semib); 
        _axialRatioSpinBox->setValue(int(_originalSource.axialRatio));

    
         F90MODPROC(omsource_glue, replace)(_sourceNo, _originalSource);
  
        _extendedSource->setChecked(true);


    }
    reporter->setProgress(35);
   

    updateDisplay();

    reporter->setProgress(36);


    getBackgroundPoints(_display);
    
    reporter->setProgress(37);
 
 
    /***************************************************************   
    *
    ***************************************************************/
    // add an information  menu:
    QPopupMenu* infoMenu = new QPopupMenu;
    
    infoMenu->insertItem("&Help", parent, SLOT(showHelpInformation()) );
 
    infoMenu->insertItem( "&Obs details",  parent, 
          SLOT(showObservationDetails()), Qt::CTRL+Qt::Key_O );
 
    infoMenu->insertItem( "&Image details",  parent, 
          SLOT(showImageDetails()), Qt::CTRL+Qt::Key_I );

    reporter->setProgress(38);

    QMenuBar* menuBar = new QMenuBar(this);
    menuBar->insertItem("&Information", infoMenu);
    reporter->setProgress(39);

    // Get the background mode from the image

    _backgroundMode = F90MODPROC(omsource_glue, getthebackgroundmode)();
    _background =   _backgroundMode;

    reporter->setProgress(40);

    text.sprintf("Uses your background pixel value\n"
                 "Currently set at the image mode (%.1f)", _background);
    QToolTip::add( _backgroundRadioBtn[2] , text);

    setGeometry(0, 0, this->width() - 20, this->height());      

    reporter->setProgress(41);
   

    initApertureSpinBoxes();
 
    delete reporter;
}
/**************************************************************
*  
*  Destroys the object and frees any allocated resources
**************************************************************/
PhotometryDlg::~PhotometryDlg()
{
    delete [] _magnitude;
    delete [] _magnitudeError;


    // Delete the background regions
    F90MODPROC(omsource_glue, deletebackgroundlist)();
      
    // no need to delete child widgets, Qt does it all for us
  
}
/*********************************************
* cancel -
*  
*********************************************/

void PhotometryDlg::cancel()
{

    F90MODPROC(omsource_glue, replace)(_sourceNo, _originalSource);
      
    reject();

}
/***********************************************
* 
*************************************************/
void PhotometryDlg::LoadSourceDetails()
{
 
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    _source = &mySources[_sourceNo];
 
 
    QString text;
  
    float totalRate =  _source->rawcountrate +  _source->rawbackgroundcountrate;
  
    float error =  sqrt(_source->rawcountrateerror * _source->rawcountrateerror +
		       _source->rawbackgroundcountrateerror * _source->rawbackgroundcountrateerror);

   
    _rawTotalRateEdt->setText(text.sprintf("%8.2f",  totalRate));
  
    _rawTotalRateErrEdt->setText(text.sprintf("%8.2f",  error));;
  
    _rawBackgroundRateEdt->setText(text.sprintf("%8.2f",  _source->rawbackgroundcountrate));
 
    _rawBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f",  _source->rawcountrate));

    _rawBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f", _source->rawcountrate  ));
  
   
    _rawBackgroundSubtractedRateErrEdt->setText(text.sprintf("%8.2f",   _source->rawcountrateerror));
  
    
    // Corrected count rates

    totalRate =  _source->corrcountrate +  _source->corrbackgroundcountrate;
  
    error =  sqrt(_source->corrcountrateerror * _source->corrcountrateerror +
		       _source->corrbackgroundcountrateerror * _source->corrbackgroundcountrateerror);

 
    _corrTotalRateEdt->setText(text.sprintf("%8.2f",  totalRate));
  

    _corrTotalRateErrEdt->setText(text.sprintf("%8.2f",  error));;
  
    _corrBackgroundRateEdt->setText(text.sprintf("%8.2f",  _source->corrbackgroundcountrate));
 
    _corrBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f", _source->corrcountrate));
    _corrBackgroundSubtractedRateErrEdt->setText(text.sprintf("%8.2f", _source->corrcountrateerror));
  
    _magnitudeEdt->setText(text.sprintf("%8.2f",  _source->magnitude));
    _magnitudeErrEdt->setText(text.sprintf("%8.2f",  _source->magnitudeerror));
    _signalToNoiseEdt->setText(text.sprintf("%8.2f",  signalToNoise(_source->corrcountrate,
						     _source->corrbackgroundcountrate, _obsDetails->exposure)));      
    _coincCorrectionEdt->setText(text.sprintf("%8.2f",  _source->coincidencecorrection));
  
    _psf1CorrectionEdt->setText(text.sprintf("%8.2f",  _source->psf1correction));
    _psf2CorrectionEdt->setText(text.sprintf("%8.2f",  _source->psf2correction));

    float deadFractionCorrection = (1.0 / (1.0 - _imageDetails->deadFraction) - 1.0) * 100.0;
    _deadFractionCorrectionEdt->setText(text.sprintf("%8.2f",  deadFractionCorrection));
 
 
}
/******************************************************
* initApertureSpinBoxes
* Purpose- Initialises the spin boxes with the default
* values
******************************************************/

void PhotometryDlg::initApertureSpinBoxes()
{

    // The aperture radius 
    _apertureSpinBox->setMaxValue(int(_apertureRadius + 0.1) * 2);
    _apertureSpinBox->setMinValue(int(_apertureRadius / 2.0 + 0.1));
    _apertureSpinBox->setValue((int)(_apertureRadius + 0.1));


    if (_source->photometryradius == 0.0)
          _apertureSpinBox->setValue((int)_apertureRadius);
    else  
          _apertureSpinBox->setValue((int)(_source->photometryradius));
  

    // The inner background annulus  

  
    _innerBckSpinBox->setMinValue(_apertureSpinBox->value() + 2);
 
    _innerBckSpinBox->setMaxValue(int(_calApertureRadius + 0.1) + 32);



   //    _innerBckSpinBox->setValue(int(_calApertureRadius + 0.1) + 2);
 

    // The outer background annulus  
    _outerBckSpinBox->setMinValue(_innerBckSpinBox->value() + 2);
    _outerBckSpinBox->setMaxValue(_innerBckSpinBox->value() + 32);

    //    cout << "Init inner=" << _source->innerbackgroundradius << endl;
    //  cout << "Init outer=" << _source->outerbackgroundradius << endl;

    if (  _innerBckRadius > 0.0)
        _innerBckSpinBox->setValue(  _innerBckRadius);
    else
        _innerBckSpinBox->setValue(_apertureSpinBox->value() + 2);
 
    if (  _outerBckRadius > 0.0)
        _outerBckSpinBox->setValue(  _outerBckRadius);
    else
        _outerBckSpinBox->setValue(_apertureSpinBox->value() + 2);
 
}
/******************************************************
* sourceHasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::apertureRadiusHasChanged(int value)
{
     
    _computeBtn->setEnabled(true);
    
    _source->photometryradius = value;

    //    if (value > (int)_apertureRadius)
    //    { 


    //    QString text;
    //    if (_calApertureRadius > 12)   	
    //        QTextOStream( &text) << "Change the background inner annulus radius\n"
    //			     << "allowed values=aperture radius + 2 - "
    //                             << (_calApertureRadius + 22) << "  pixels\n"
    //                             << "Note that the point-spread function\n"
    //			     << "extends to " <<   _calApertureRadius << " pixels";
       
    //    else
    //      QTextOStream( &text) << "Change the background inner annulus radius\n"
    //                           << "allowed values=" << (value + 2) << " - " 
    //                           << (value + 22) << " pixels\n"
    //                           << "Note that the point-spread function\n"
    //			   << "extends to " <<   _apertureRadius << " pixels";
       

    //    QToolTip::remove(_innerBckSpinBox);
    //    QToolTip::add(_innerBckSpinBox, text);
    //    QToolTip::remove(_innerBckTxt);
 
    //    QToolTip::add(_innerBckTxt, text);

 

    _innerBckSpinBox->setMinValue(value + 2);
    _innerBckSpinBox->setMaxValue(value + 32);
  

    if (value > _innerBckSpinBox->value() - 2)
    {
         _innerBckSpinBox->setValue(value + 2);

  

        innerAnnulusRadiusHasChanged(value + 2);
    }
	//    }
    if (_timer->isActive()) return;
    _timer->start(2000, FALSE );
    
   
}
/******************************************************
* innerAnnulusRadiusGasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::innerAnnulusRadiusHasChanged(int value)
{
  
    _computeBtn->setEnabled(true);
 
    _outerBckSpinBox->setMinValue(value + 2);
    _outerBckSpinBox->setMaxValue(value + 32);
    _source->innerbackgroundradius = value;
    
    if (_outerBckSpinBox->value() < _innerBckSpinBox->value() + 2)
    {
        _outerBckSpinBox->setValue(value + 2);

        _source->outerbackgroundradius = value + 2;
    }
  

    if (_timer->isActive()) return;
    _timer->start(2000, FALSE );
       
}
/******************************************************
* outerAnnulusRadiusGasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::outerAnnulusRadiusHasChanged(int value)
{  
    _computeBtn->setEnabled(true);
    _source->outerbackgroundradius = value;

    if (_outerBckSpinBox->value() <  _innerBckSpinBox->value() + 2)
    {
 
        _innerBckSpinBox->setValue(value - 2);


    }

   if (_timer->isActive()) return;
  _timer->start(2000, FALSE );
     
}
/******************************************************
* eccentricityHasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::axialRatioHasChanged(int value)
{  
    _computeBtn->setEnabled(true);
    
   _source->axialRatio  = float(value);
   //  cout << "Line 1284 axialratio  has changed aperture radius=" << _source->photometryradius << endl;
   
 
   if (_timer->isActive()) return;
 
   _timer->start(2000, FALSE );
    
   
}
/******************************************************
* positionAngleasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::positionAngleHasChanged(int value)
{  
  _computeBtn->setEnabled(true);
  
  _source->alpha = float(value);

  //  cout << "Line 1310 positionAngle has changed aperture radius=" << _source->photometryradius << endl;
 
  if (_timer->isActive()) return;
  _timer->start(2000, FALSE );
    
 
}
/*********************************************************
 *
 ********************************************************/
void PhotometryDlg::updateDisplay()
{
       

 
    // Get the user selected points from the image
  
    _source->number = _sourceNo;

    //    cout << "Update display photometry radius=" << _source->photometryradius << endl;
    _display->zoomTo(*_source, _zoomFactor);

     
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mybackgroundsources);
   

    if (mySources.ubound()  > 1)
    {

    
        _display->displayBackgroundRegions(mySources);
    
  
    } 
  

 
   if (_timer->isActive()) _timer->stop();
    

}
/******************************************************
* recompute
* This is activated from OmSourceEditor when the apply
* button is clicked.
*******************************************************/
void PhotometryDlg::compute()
{

  //  cout << "Line 1358 compute aperture radius=" << _source->photometryradius << endl;


    if (!_fixedBackground)
       _source->rawbackgroundcountrate = -1.0;
    else 
       _source->rawbackgroundcountrate = _background;
 
    //    float radius =  _source->photometryradius;

    //    cout << "Line 1367 source->rawbackgroundcountrate=" << _source->rawbackgroundcountrate 
    //        << " backround=" << _background << endl; 
    //  cout << "Line 1370 compute aperture radius=" << _source->photometryradius << endl;


    F90MODPROC(omsource_glue, replace)(_sourceNo, *_source);
  
    //  cout << "Line 1368 compute aperture radius=" << _source->photometryradius << endl;


  //    resetSource();  
    if(_backgroundRadioBtn[1]->isChecked())
    {
     

      
        if (!getBackgroundPoints(_display)) 
        {

            QMessageBox::critical( 0, "omsource",
			       QString("No regions have been selected for background determination\n\n\n" 
                                 "Please select one or more background regions")); 


            return;
        }
       
                
    }

 
    _finishButton->setEnabled(true);
    _computeBtn->setDisabled(true);
 

    // Display the dialogue to do the photometry
    QString caption =  "Computing photometry- please wait";
    ProcessDlg *processDlg = new ProcessDlg(this, _sourceNo, caption, 
            ProcessDlg::aperturePhotometry);
   
    processDlg->exec();

    delete processDlg;  


    // Retrieve the new source parameters

   
     OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    
    *_source = mySources[_sourceNo];


    //    cout << "Line 1405radius=" << _source->photometryradius << " radius=" << radius << endl;

    //    _source->photometryradius = radius;   // Need this because if extended-source aperture photometry will have set it 
   

   _logger->add(*_source);
 
    LoadSourceDetails();
    _averageMagList->setEnabled(true);
    computeAverage();
    
}
/******************************************************
* print
******************************************************/
void PhotometryDlg::print()
{
#ifndef QT_NO_PRINTER

    QPrinter printer; 
    if ( printer.setup(this) ) {                // opens printer dialog
        printer.setFullPage(TRUE);              // we'll set our own margins
	QPainter p;
	p.begin( &printer );                    // paint on printer
	p.setFont( p.font() );
	QFontMetrics fm = p.fontMetrics();
	QPaintDeviceMetrics metrics( &printer ); // need width/height
                                                 // of printer surface
    
        /*********************************************
	* Print what ever
	********************************************/
        (this->*Print)(&printer, &p,  &fm,  &metrics);

	p.end();                                // send job to printer
    }
#endif
}

/*********************************************************
* print1
**********************************************************/
void PhotometryDlg::print1()
{
    Print = &PhotometryDlg::printAverages;
    print();
}
/*********************************************************
* print2
**********************************************************/
void PhotometryDlg::print2()
{     
    Print = &PhotometryDlg::printLog;
    print();
}

/*********************************************************
* printAverages
* Prints the contents of the combo box that stores
* the average magnitudes
*********************************************************/
void PhotometryDlg::printAverages(QPrinter* printer, QPainter* p,  
               QFontMetrics* fm,  QPaintDeviceMetrics* metrics)
{
    const int MARGIN = metrics->logicalDpiX() / 2; // half-inch margin
    int yPos        = MARGIN;               // y position for each line


    printHeading(p,  fm, metrics, MARGIN, yPos);
 

    for( int i = 0 ; i < _averageMagList->count(); i++ ) 
    {
        if ( printer->aborted() )
            break;
        if ( yPos + fm->lineSpacing() > metrics->height() - MARGIN ) 
        {
                // no more room on this page
                if ( !printer->newPage() )          // start new page
                    break;                          // some error
                yPos = MARGIN;                      // back to top of page
        }
        p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, _averageMagList->text(i));
        yPos += fm->lineSpacing();
    }

}

/*****************************************************************************
*
* printHeading
****************************************************************************/
void PhotometryDlg::printHeading(QPainter* p,  
                                  QFontMetrics* fm,  
                                  QPaintDeviceMetrics* metrics,
                                  const int MARGIN, int &yPos)
{
    QDateTime date = QDateTime::currentDateTime();  // The current date and time
    
    QString text = QString("Listing produced by ") + omsourceVersionNo() + QString("  ") + date.toString();  
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 2 * fm->lineSpacing();
   
    text = "TELESCOPE=" + _obsDetails->telescope + " INSTRUMENT=" + _obsDetails->instrument;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "OBS_ID=" + _obsDetails->obsId + " EXP_ID=" + _obsDetails->expId;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "DATE-OBS=" + _obsDetails->dateObs + " DATE-END=" + _obsDetails->dateEnd;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "OBJECT=" + _obsDetails->object + " OBSERVER=" + _obsDetails->observer;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text.sprintf("FILTER=%s EXPOSURE=%d (SECONDS)", (const char *)_obsDetails->filter, 
           (int)_obsDetails->exposure);
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 5 * fm->lineSpacing();

}
/*********************************************************
* printLog
* Prints the contents of the table that stores the
* user photometry calculations
*********************************************************/
void PhotometryDlg::printLog(QPrinter* printer, QPainter* p,  
               QFontMetrics* fm,  QPaintDeviceMetrics* metrics)
{
    const int MARGIN = metrics->logicalDpiX() / 2; // half-inch margin
    int yPos        = MARGIN;               // y position for each line

    printHeading(p, fm, metrics, MARGIN, yPos);


    QString text;
    text.sprintf("Source no %d - photometry calculations", _sourceNo);
    p->drawText (MARGIN, yPos, text); 
    yPos += 2 * fm->lineSpacing();
    QString heading[] = {"Photometry aperture radius (unbinned pixels)",
                         "Photometry inner background annulus radius (unbinned pixels)",
                         "Photometry outer background annulus radius (unbinned pixels)",
                         "Instrumental magnitude (corrected for coincidence losses & psf corrections)",
                         "Instrumental magnitude error",
                         "Signal-to-noise ratio)",
                         "Coincidence-loss correction (%)"}; 
 
    for (int i = 0; i <  _logger->numCols(); i++)
    {
        QString text;

        text.sprintf("Column %d=%s", i + 1, (const char *)heading[i]); 
        p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);

        yPos += fm->lineSpacing();
        
    }
     
    yPos += fm->lineSpacing();
   
    for( int i = 1 ; i < _logger->numRows(); i++ ) 
    {
        if ( printer->aborted() )
            break;
        if ( yPos + fm->lineSpacing() > metrics->height() - MARGIN ) 
        {
                // no more room on this page
                if ( !printer->newPage() )          // start new page
                    break;                          // some error
                yPos = MARGIN;                      // back to top of page
        }

        QString text;
        for (int j = 0; j < _logger->numCols(); j++)
	{
	  text += _logger->text(i, j) + QString("        ");
           

        }
   
       p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);


        yPos += fm->lineSpacing();
    }

}
/*********************************************
 *
 *******************************************/
void PhotometryDlg::deleteAverageMagList()  
{ 
    _averageMagList->clear();
    
    _logger->setNumRows(0);

    _printAveragesBtn->setDisabled(true);
    _deleteAveragesBtn->setDisabled(true);
    _count = 0;
    repaint();
}; 


/******************************************************
* edit
*******************************************************/

void PhotometryDlg::computeAverage()
{
    
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
     
    // Recompute the average magnitude 
      
    _magnitude[_count] = mySources[_sourceNo].magnitude;
    _magnitudeError[_count] = mySources[_sourceNo].magnitudeerror;
    
    if (_count > 0) 
    {

        float mean, standardDeviation;
       
        ComputeAverageMagnitude(_magnitude, _magnitudeError, _count + 1, mean, standardDeviation);
        QString text;
        text.sprintf("Average magnitude for source %d=%5.2f+/-%5.2f (n=%d)", 
               _sourceNo, mean, standardDeviation, _count + 1); 
        
        _averageMagList->setEnabled(true);

        _printLogBtn->setEnabled(true);
        _printAveragesBtn->setEnabled(true);
        _deleteAveragesBtn->setEnabled(true);


        _averageMagList->insertItem(text);
        _averageMagList->setEditText(text);

        _averageMagList->setCurrentItem(_averageMagList->count() - 1); 
    }
    _count++;

     
}
/***************************************************************
*
**************************************************************/
void PhotometryDlg::pointSourceCheckBoxHasChanged(bool checked)     
{
  _computeBtn->setEnabled(true);
  
  if (checked)
  {

    //    _growthCurveBtn->setEnabled(true);
   
    _extendedSource->setChecked(false);
  
    _axialRatioTxt -> setDisabled(true);
 
    _axialRatioSpinBox -> setDisabled(true);
    _positionAngleTxt -> setDisabled(true);
 
    _positionAngleSpinBox -> setDisabled(true);

   

    _source = &_pSource;
    
 
                         
  }
  else
  {
 
    _source = &_eSource;


   //   _growthCurveBtn->setDisabled(true);
   
    _axialRatioTxt -> setEnabled(true);
 
    _axialRatioSpinBox -> setEnabled(true);
    _positionAngleTxt -> setEnabled(true);
 
    _positionAngleSpinBox -> setEnabled(true);
    _extendedSource->setChecked(true);
     _source->extensionflag = true;

    _source->axialRatio = _axialRatioSpinBox->value();; 
 
    _source->alpha = _positionAngleSpinBox->value();
    
 

  } 
  if(_displayUpdated)
      _displayUpdated = false;
  else
  {
     _displayUpdated = true; 
      updateDisplay();
  }
}
/****************************************************************
*
***************************************************************/
void PhotometryDlg::extendedSourceCheckBoxHasChanged(bool checked)     


{

    _computeBtn->setEnabled(true);
  
    if (checked)
    {
        _source = &_eSource;
        _axialRatioTxt -> setEnabled(true);
 
        _axialRatioSpinBox -> setEnabled(true);
        _positionAngleTxt -> setEnabled(true);
 
        _positionAngleSpinBox -> setEnabled(true);


        _pointSource->setChecked(false);
    
        _source->alpha = _positionAngleSpinBox->value();
        _source->axialRatio = _axialRatioSpinBox->value();

    }
    else
    {
    
        _source = &_pSource;
   
        _axialRatioTxt -> setDisabled(true);
 
        _axialRatioSpinBox -> setDisabled(true);
        _positionAngleTxt -> setDisabled(true);
 
        _positionAngleSpinBox -> setDisabled(true);
        _pointSource->setChecked(true);
    }
    if(_displayUpdated)
        _displayUpdated = false;
    else
    {
        _displayUpdated = true; 
        updateDisplay();
    }       

}

/****************************************************************
*
***************************************************************/

void PhotometryDlg::showPhotometryInformation()
{

   
  //static const char* sayings[] = {
    static const QString sayings[] = {
     "<center><i>Overview of photometry</i></center>",

    "<b>Step 1 - Aperture Counts:</b><br>"
    "<hr><br><br>"
    "<big>Sum up the pixel counts within the aperture </big><br><br>"
    "<center><i>-- H.L. Mencken</i></center>",

    "<b>Step 2- Background Estimation:</b><br>"
    "<hr><br><br>"
    "<big>Obtain an estimate of the background<br>"
    "from the pixels within the background aperture<br>"
    
    "These are great mysteries.</big><br><br>"
    "<center><i>-- Geoffrey James, \"The Tao of Programming\"</i></center>",

    "<b>Obtain the Source Counts:</b><br>"
    "<hr><br><br>"
    "<big>Subtract the background from the total counts</big><br><br>"
    "<center><i>-- Martin Mull</i></center>",

    "<b>Saying 4:</b><br>"
    "<hr><br><br>"
    "<big><b>The Least Successful Executions</b><br>"
    "<twocolumn><p>      History has furnished us with two executioners worthy of attention. "
    "The first performed in Sydney in Australia.  In 1803 three attempts were "
    "made to hang a Mr. Joseph Samuels.  On the first two of these the rope "
    "snapped, while on the third Mr. Samuels just hung there peacefully until he "
    "and everyone else got bored.  Since he had proved unsusceptible to capital "
    "punishment, he was reprieved.</p>"
    "<p>        The most important British executioner was Mr. James Berry who "
    "tried three times in 1885 to hang Mr. John Lee at Exeter Jail, but on each "
    "occasion failed to get the trap door open.<!p>"
    "<p>        In recognition of this achievement, the Home Secretary commuted "
    "Lee's sentence to \"life\" imprisonment.  He was released in 1917, emigrated "
    "to America and lived until 1933.</p></twocolumn></big><br><br>"
    "<center><i>-- Stephen Pile, \"The Book of Heroic Failures\"</i></center>",

    "<b>Saying 5:</b><br>"
    "<hr><br><br>"
    "<big>If you can, help others.  If you can't, at least don't hurt others.</big><br><br>"
    "<center><i>-- the Dalai Lama</i></center>",

    "<b>Saying 6:</b><br>"
    "<hr><br><br>"
    "<big>Television has brought back murder into the home -- where it belongs.</big><br><br>"
    "<center><i>-- Alfred Hitchcock</i></center>",

    "<b>Saying 7:</b><br>"
    "<hr><br><br>"
    "<big>I don't know who my grandfather was; I am much more concerned to know "
    "what his grandson will be.</big><br><br>"
    "<center><i>-- Abraham Lincoln</i></center>",

    0
};


    HelpDlg *helpDlg = new HelpDlg(this, sayings);


    

    helpDlg->exec();
    
     
    delete helpDlg;  
 
}
/***********************************************************
*
*
*
***********************************************************/
void PhotometryDlg::mousePressEvent( QMouseEvent* event)
{
  QApplication::beep();
  if ( event->button() == RightButton )
  {   

      QPopupMenu *informationMenu  = new QPopupMenu( this );
    
      InformationMenu(parentWidget(), informationMenu);
    
 
   

      //      informationMenu->insertItem( "&Photometry information",  this, 
      //          SLOT(showPhotometryInformation()), Qt::CTRL+Qt::Key_I );
 
   
      informationMenu->exec(QCursor::pos() );

  
      delete informationMenu;
      
    
  }
  
}   

void PhotometryDlg::paintEvent( QPaintEvent * )
{
  return;
  int b = 10;
    static int sin_tbl[16] = {
        0, 38, 71, 92, 100, 92, 71, 38, 0, -38, -71, -92, -100, -92, -71, -38};
    QString t = "One two three four five";
    if ( t.isEmpty() )
        return;

    // 1: Compute some sizes, positions etc.
    QFontMetrics fm = fontMetrics();
    int w = fm.width(t) + 20;
    int h = fm.height() * 2;
    int pmx = width()/2 - w/2;
    int pmy = height()/2 - h/2;

    // 2: Create the pixmap and fill it with the widget's background
    QPixmap pm( w, h );
    pm.fill( this, pmx, pmy );

    // 3: Paint the pixmap. Cool wave effect
    QPainter p;
    int x = 10;
    int y = h/2 + fm.descent();
    int i = 0;
    p.begin( &pm );
    p.setFont( font() );
    while ( !t[i].isNull() ) {
        int i16 = (b+i) & 15;
        p.setPen( QColor((15-i16)*16,255,255,QColor::Hsv) );
        p.drawText( x, y-sin_tbl[i16]*h/800, t.mid(i,1), 1 );
        x += fm.width( t[i] );
        i++;
    }
    p.end();

    // 4: Copy the pixmap to the Hello widget
    bitBlt( this, pmx, pmy, &pm ); 


}
/***************************************************
* Displays the background dialogue that
* allows the user to select circular regions
* for background determination
***************************************************/
void PhotometryDlg::showBackgroundDlg()
{
   
    BackgroundDlg *backgroundDlg = new BackgroundDlg(this, _display, _source, _zoomFactor);
    
    backgroundDlg->exec();
    
    _background = backgroundDlg->getBackgroundMode();  
    _backgroundRegionsValue = _background;   
      
    //    cout << "PhotometryDlg line 2049 _background=" << _background << endl;


    delete backgroundDlg;  
 
}
/******************************************************
 *
 *****************************************************/
void PhotometryDlg::stopTimer()
{

   _timer->stop();
   // cout << "Line 2062 stopTimer aperture radius=" << _source->photometryradius << endl;
  
}
/*******************************************************
* 
*  For getting the user-selected background regions
******************************************************/
bool PhotometryDlg::getBackgroundPoints(OmImageDisplay *display)
{
    OmSourceRegions *points = OmImageRegions::GetRegions(display);
        
    if (points) {
   
        F90MODPROC(omsource_glue, getbackgroundregions)(points);
    
  
	delete points;       
    }
    else
        return false;   // Need to delete them 
 
  
    // Get the background sources
    OmSourceParameters& backgroundSources = F90MODVAR(omsource_glue, mybackgroundsources);


    if (backgroundSources.ubound() < 1)          
    {   
        return false;
    }
    
    return true;
    
}
/***************************************************
 *
 ***************************************************/
void PhotometryDlg::displayGrowthCurve()
{
  
  //    Graph *graph = new OmSourceGraph(this, &_originalSource, 
  //           "Radius (pixels)", "Delta magnitude",
  //           "APERTURE GROWTH-CURVE");    

  //    GraphDlg *graphDlg = new GraphDlg(this, graph);
   
   
  //    graphDlg->exec();
     
  //    delete graphDlg;  
  //    delete graph;
   
}
/***************************************************
*
***************************************************/
void PhotometryDlg::updateBackgroundDetermintaion(int index)
{


    _computeBtn->setEnabled(true);
    
    switch(index)
    {
    case (0):   // Background from annulus
        _backgroundBtn->setDisabled(true);
        _background = -1.0;        
        _fixedBackground = false;
     
	break; 
    case (1):   // Background from user-selected regions
 
        _fixedBackground = true;
        _backgroundBtn->setEnabled(true);
        _computeBtn->setEnabled(true);
        _background = _backgroundRegionsValue;   
 
        if (!getBackgroundPoints(_display))
        {

	    showBackgroundDlg();

	   
        }

        break;
    case (2):  // User-fixed background
      /*****************************************************
      * Background subtraction using the user-supplied value
      *****************************************************/
       _backgroundBtn->setDisabled(true);
       _fixedBackground = true;
    
       _background = _backgroundUserValue;   
       
       bool ok;
       float value = _background > 0.0 ? _background : _backgroundMode; 
       float minValue =  max(0.0001, value - 20.0);
       float maxValue = value + 20.0;
       QString text;
       text.sprintf("%s%6.1f%s%6.1f%s%6.1f%s%6.1f", "Please change if required-\n"
		    "The allowed range of values is ", minValue, "-", maxValue, 
                    "\nThe computed mode value is", _backgroundMode,
                    "\nThe last user value was ", _backgroundUserValue);
       double res = QInputDialog::getDouble( "Please select your background value (counts/pixel)", 
                  text, value, max(0.0, value - 20.0),
                   value + 20.0, 1, &ok, this );  // The 1 is the number of decimal places
      
       if ( ok ) {
 
           // user entered something and pressed OK
           _background = res;
          
           _backgroundUserValue = res;   
           QString text;

           text.sprintf("Uses your background pixel value %.1f", _background);
           QToolTip::add( _backgroundRadioBtn[2] , text);
  
  
       } else {
        // user pressed Cancel
       }

   
       break;


    }
}
/************************************************************
*
***********************************************************/
void PhotometryDlg::resetSource()
{


    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    OmSourceParameter tempSource =  mySources[_sourceNo];

    tempSource.rawbackgroundcountrate = _background;
            
    F90MODPROC(omsource_glue, replace)(_sourceNo, tempSource);
    
}
/************************************************************
*
***********************************************************/
float PhotometryDlg::signalToNoise(const float & source, const float &background, const float &exposure)
{

    float s = source * exposure;
    float b = background * exposure;

    return s / sqrt(s + b);


}









