#ifndef OmSourceProcessDlg_h
#define OmSourceProcessDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
class QSpinBox;


#include "OmSourceLog.h"
#include "OmImageDisplay.h"
#include "OmSourceVersionNo.h"

F90MODPROCPROTO(void,omsource_glue, recompute)(const int& id);
F90MODPROCPROTO(void, omsource_glue, computephotometry)(OmSourceParameters &sources);


class QLabel;;
class ProcessDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
    

    void runProcess1();    
    void pause1();  
    void runProcess2();    
    void pause2();  
  

      public:
    ProcessDlg(QWidget *parent, int no = 0, 
           QString text = QString::null, 
           void (*function)(int sourceNo = 0) = NULL);
    
    ProcessDlg(QWidget *parent, OmSourceParameters *source, 
           QString text = QString::null, 
           void (*function)(OmSourceParameters *source) = NULL);
 
    static void aperturePhotometry(int sourceNo)
    {

         
        F90MODPROC(omsource_glue, recompute)(sourceNo);
 

    }; 
    static void aperturePhotometry(OmSourceParameters *source)
    {

         
        F90MODPROC(omsource_glue, computephotometry)(*source);
    

    }; 


    static void createNewSourceListFile(int no = 0);    
 private:
    int _sourceNo;
    OmSourceParameters *_source;
    QString _caption;
    QLabel *_label;
    void (*Function1)(int sourceNo = 0);    
    void (*Function2)(OmSourceParameters *_source);    

};

#endif



