
#include <qinputdialog.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qstring.h>

#include "qapplication.h"
#include "qmessagebox.h"
#include <param.h>

#include "OmSourceUtility.h"
/************************************************************
* GetOldFileName
*************************************************************/
void GetOldFileName(QWidget *parent, char oldFileName[], 
           const char *parameter, const char *title, const QString filterList[])
{ 
    string fileName = stringParameter(parameter);
    QFileDialog fd(QString::null, filterList[0], 
                       parent , title);
    fd.setCaption(title);
    fd.setMode(QFileDialog::ExistingFile);
   int i = 1;
   while(filterList[i])
   {

       fd.addFilter(filterList[i++]);
   }
 

       
    if (fileName == string("") || !QFile::exists((const QString)fileName.c_str()))
    {

        /**************************************************
	* Display get file name dialog
	*************************************************/ 

        bool okay = FALSE;
        QString text;
   
        while (!okay)
	{
	    QApplication::beep();        
 
            if ( fd.exec() == QDialog::Accepted )
	      text = fd.selectedFile();

         
              
              if ( text.isEmpty() || !QFile::exists((const QString)text))
            {  
	
                int ret = QMessageBox::critical(0, "No existing file has been selected",
					      "Do you wish to try again (yes), or exit (No/Cancel)",
					      QMessageBox::Yes | QMessageBox::Default,
                                              QMessageBox::No,
                                              QMessageBox::Cancel | QMessageBox::Escape );
              
              switch (ret)
	      {
	      case   (QMessageBox::Yes):
		      okay = FALSE; 
		      break;
	      case   (QMessageBox::No):
		      exit(0); 
		      break;
	      case   (QMessageBox::Cancel):
		      exit(0); 
		      break;
	      default:
		break;
	      }
            }
            else
	 break;
                     
        }
                      
        fileName = string((const char *)text);
     
    }
        
    strcpy(oldFileName, fileName.c_str());
    
}
/************************************************************
* GetNewFileName
*************************************************************/
 
bool GetNewFileName(QWidget *parent, char newFileName[], 
            const char *parameter, const QString title, const QString caption)
{ 
    string fileName = stringParameter(parameter);
    

    bool okay = FALSE;

    if (fileName  != string(""))
    {

        if (!QFile::exists(fileName.c_str())) return true;
        
        int ret = QMessageBox::critical(0, "File already exists",
		     "Do you wish to type in another file (yes/no), or exit (Cancel)",
		     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No,
                     QMessageBox::Cancel | QMessageBox::Escape );
            switch (ret)
	    {
	      case   (QMessageBox::Yes):
		      okay = FALSE; 
                      
		      break;
	      case   (QMessageBox::No):
		     
		      strcpy(newFileName, fileName.c_str());
                      return true;
		      break;
	      case   (QMessageBox::Cancel):
   

		      return false; 
		      break;
	      default:
		break;
	    }
    }

    
        
    while (!okay)
    {

        QString text = QInputDialog::getText(
                            title, caption, QLineEdit::Normal,
                            QString::null, &okay, parent );
    

        if (okay && text.isEmpty()) {
	  okay = false;
            continue;
        } 
	if (!okay) return false;    

        fileName = string((const char*)text);
                       
        if (QFile::exists(fileName.c_str()))
	{
	    int ret = QMessageBox::critical(0, "File already exists",
		     "Do you wish to type in another file (yes/no), or exit (Cancel)",
		     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No,
                     QMessageBox::Cancel | QMessageBox::Escape );
            switch (ret)
	    {
	      case   (QMessageBox::Yes):
		      okay = FALSE; 
		      break;
	      case   (QMessageBox::No):
		      okay = TRUE;
		       
		      break;
	      case   (QMessageBox::Cancel):


		      return false; 
		      break;
	      default:
		break;
	    }
	 }

	
              
    }
     
 
    strcpy(newFileName, fileName.c_str());
    return true;
}
